# encoding: Windows-31J
#
#	$B%+!<%I(B
#
#

class BaseItem < Sprite
	attr_accessor :dx, :dy, :rx, :ry, :cx, :cy, :tag,:id,:maxhp,:hp,:base_turn,:ad,:hit,:dodge,:effect,:mes
	def initialize(x,y)
		super
		@x = x
		@y = y
		@dx = 0
		@dy = 0
	end

	def overMouse?
		if((self.x<Input.mousePosX)&&(Input.mousePosX<self.x+self.image.width)&&(self.y<Input.mousePosY)&&(Input.mousePosY<self.y+self.image.height)) then
			return true
		end
		return false
	end
	
	def pushClick?
		if ((self.overMouse?)&&(Input.mousePush?(M_LBUTTON))) then
			return true
		end
		return false
	end
	
	def onClick?
		if ((self.overMouse?)&&(Input.mouseDown?(M_LBUTTON))) then
			return true
		end
		return false
	end
	
	def update
	
	end
	
	def shot(obj)
	end
	
	def hit
	end

end

class BaseCard < BaseItem
	def initialize(cx,cy)
		super
		@tag = "CARD"
		@base_x = cx
		@base_y = cy
		self.cx = cx
    	self.cy = cy
		
	end
	
	def update
		
		$status_mes_1=Kconv.tosjis("$BL?Cf(B:"+@hit.to_s+"%")
		$status_mes_2=Kconv.tosjis("$B2sHr(B:"+@dodge.to_s+"%")
		self.image.drawFont(2,0,$status_mes_1,$font,[10,10,10])
		self.image.drawFont(20,60,$status_mes_2,$font,[10,10,10])
		if(self.onClick?)
			#$B!!%/%j%C%/$5$l$F$$$k$H$-$N=hM}(B
			$item_click.push(self)
		else
			#$B!!%/%j%C%/$,OC$5$l$?$H$-$N=hM}(B
			if($item_click[0]==self)
				self.drop
			end
			$item_click.delete(self)
		end

		if($item_click[0]==self)
			self.drag
		end

		#$B!!:BI8$N99?7(B
		self.x = self.cx - self.image.width / 2
		self.y = self.cy - self.image.height / 2
	end
	
	def drag
		# $B:BI8$r%^%&%9%+!<%=%k$NCf?4$K$7$^$9(B
		self.cx = Input.mousePosX
		self.cy = Input.mousePosY
	end
	
	def drop
		temp = $object_list.find_all{|n|
			(n !=self)&&(n.tag != "BackGround")
		}
		temp = self.check(temp)
		if(!temp.empty?)
			#$B<+J,$KBP>]$N%*%V%8%'%/%H$rAw$j$^$9(B
			self.shot(temp[0]) if(!temp.empty?)
		end
		self.cx = @base_x
		self.cy = @base_y
	end

end


class Enemy < BaseItem
	@@image=Image.load('./image/enemy0.png')
	def initialize(cx,cy)
		super
		self.tag = "ENEMY"
		self.cx = cx
    	self.cy = cy
		self.image = @@image
		self.x = self.cx - self.image.width / 2
		self.y = self.cy - self.image.height / 2
		@base_x = self.x
		@base_y = self.y
		self.maxhp = $enemy_maxhp
		self.hp = self.maxhp
		self.base_turn = 3
		@shake_time=0
	end

	def update
		$enemy_hp = self.hp
		self.shake(@shake_time)
	end

	def hit
		@shake_time=16
		DataBase.sound[:ATTACK1].play
	end
	
	def shake(time)
		if(@shake_time>0)
			self.x = Math.sin((3.14/2)*@shake_time)*20+@base_x
			self.y = -Math.sin((3.14/4)*@shake_time)*20+@base_y
			@shake_time-=1
		end
	end

end

class BackGround < BaseItem
	@@image=Image.load('./image/battle_0.png')
	def initialize(x,y)
		super
		@tag = "BackGround"
		self.image = @@image
	end
	
	def update
		
	end
end


class GaugeHP < BaseItem
	@@image=Image.new(240,20,[160,160,160])
	def initialize(x,y)
		super
		self.alpha = 220
		self.image = @@image
		self.x = x
		self.y = y
	end

	def update
		temp = 240*$enemy_hp/$enemy_maxhp
		temp.to_i
		self.image.boxFill(0,0,240,25,[160,160,160])
		self.image.boxFill(0,0,temp,25,[28,255,28])
	end
end

class WindowDraw < BaseItem
	@@image = Image.load('./image/draw.bmp')
	def initialize(x,y)
		super
		self.image = @@image
		self.x = x
		self.y = y
	end
	
	def update
		if(self.pushClick?)
			$object_list.clear
			$scene = SceneTitle.new
			$scene.init
		end
	end
	
	def drawPhase
		
	end
end

class WindowWaku < BaseItem
	@@image = Image.load('./image/waku.png')
	def initialize(x,y)
		super
		self.image = @@image
		self.x = x
		self.y = y
	end
end

class BackGroundTitle < BaseItem
	@@image=Image.load('./image/title.bmp')
	def initialize(x,y)
		super
		@tag = "BackGround"
		self.image = @@image
	end
	
	def update
		# $B@oF.2hLL$KHt$V(B
		if((384<Input.mousePosX)&&(Input.mousePosX<575)&&(32<Input.mousePosY)&&(Input.mousePosY<95)) then
			if (Input.mousePush?(M_LBUTTON)) then
				$object_list.clear
				$scene = SceneBattle.new
				$scene.init
			end
		end
		
		#$B?^4U2hLL(B
		if((416<Input.mousePosX)&&(Input.mousePosX<640)&&(128<Input.mousePosY)&&(Input.mousePosY<190)) then
			if (Input.mousePush?(M_LBUTTON)) then
				$object_list.clear
				$scene = SceneZukan.new
				$scene.init
			end
		end
		
		#$B2;3Z2hLL(B
		if((416<Input.mousePosX)&&(Input.mousePosX<543)&&(256<Input.mousePosY)&&(Input.mousePosY<320)) then
			if (Input.mousePush?(M_LBUTTON)) then
				$object_list.clear
				$scene = SceneMusic.new
				$scene.init
			end
		end
	end
end

class BackGroundZukan < BaseItem
	@@image=Image.load('./image/zukan.bmp')
	def initialize(x,y)
		super
		@tag = "BackGround"
		self.image = @@image
	end
	
	def update
		# $B%?%$%H%k2hLL$KHt$V(B
		if((512<Input.mousePosX)&&(Input.mousePosX<608)&&(32<Input.mousePosY)&&(Input.mousePosY<128)) then
			if (Input.mousePush?(M_LBUTTON)) then
				$object_list.clear
				$scene = SceneTitle.new
				$scene.init
			end
		end
	end
end

class BackGroundMusic < BaseItem
	@@image=Image.load('./image/music_room.bmp')
	def initialize(x,y)
		super
		@tag = "BackGround"
		self.image = @@image
	end
	
	def update
		# $B%?%$%H%k2hLL$KHt$V(B
		if((512<Input.mousePosX)&&(Input.mousePosX<608)&&(32<Input.mousePosY)&&(Input.mousePosY<128)) then
			if (Input.mousePush?(M_LBUTTON)) then
				$object_list.clear
				$scene = SceneTitle.new
				$scene.init
			end
		end
		
		# $B2;3Z#1$r:F@8$9$k(B
		if((64<Input.mousePosX)&&(Input.mousePosX<352)&&(64<Input.mousePosY)&&(Input.mousePosY<128)) then
			if (Input.mousePush?(M_LBUTTON)) then
				puts(DataBase.music[:BATTLE0])
				DataBase.music[:BATTLE0].play(2, 0)
				DataBase.music[:BATTLE1].stop
				DataBase.music[:BATTLE2].stop
				
			end
		end
		
		# $B2;3Z#2$r:F@8$9$k(B
		if((64<Input.mousePosX)&&(Input.mousePosX<352)&&(192<Input.mousePosY)&&(Input.mousePosY<256)) then
			if (Input.mousePush?(M_LBUTTON)) then
				DataBase.music[:BATTLE0].stop
				DataBase.music[:BATTLE1].play(2, 0)
				DataBase.music[:BATTLE2].stop
			end
		end
		
		# $B2;3Z#3$r:F@8$9$k(B
		if((64<Input.mousePosX)&&(Input.mousePosX<352)&&(320<Input.mousePosY)&&(Input.mousePosY<384)) then
			if (Input.mousePush?(M_LBUTTON)) then
				DataBase.music[:BATTLE0].stop
				DataBase.music[:BATTLE1].stop
				DataBase.music[:BATTLE2].play(2, 0)
				
			end
		end
	end
end
